
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 10,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _T=R4
	.DEF _X1=R6
	.DEF _X2=R8
	.DEF _X3=R10

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x3:
	.DB  0xFC,0xFE,0x7,0x3,0x3,0x7,0xFE,0xFC
	.DB  0x0,0x0,0x18,0xC,0x6,0xFF,0xFF,0x0
	.DB  0x0,0x0,0x0,0x0,0x8C,0xCE,0xC3,0xC3
	.DB  0xC3,0xC3,0x7E,0x3C,0x0,0x0,0xC,0xE
	.DB  0x7,0x3,0x43,0xE3,0xFE,0xBC,0x0,0x0
	.DB  0xFF,0xFF,0xC0,0xC0,0xC0,0xC0,0xFF,0xFF
	.DB  0x0,0x0,0xFF,0xFF,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0x83,0x0,0x0,0xFC,0xFE,0xC3,0xC3
	.DB  0xC3,0xC3,0x8E,0xC,0x0,0x0,0x3,0x3
	.DB  0x3,0xE3,0xF3,0x1B,0xF,0x7,0x0,0x0
	.DB  0x3C,0xFE,0xC7,0xC3,0xC3,0xC7,0xFE,0x3C
	.DB  0x0,0x0,0x3C,0x7E,0xC7,0xC3,0xC3,0xC7
	.DB  0xFE,0xFC,0x0,0x0,0x0,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC0,0xC0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC,0xC,0x0,0x0,0x0,0x0,0x0
	.DB  0x3C,0x7E,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x1F,0x3F,0x38,0x30
	.DB  0x30,0x38,0x3F,0x1F,0x0,0x0,0x30,0x30
	.DB  0x30,0x3F,0x3F,0x30,0x30,0x30,0x0,0x0
	.DB  0x3F,0x3F,0x31,0x30,0x30,0x30,0x30,0x30
	.DB  0x0,0x0,0x18,0x38,0x30,0x30,0x30,0x38
	.DB  0x1F,0xF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3F,0x3F,0x0,0x0,0x30,0x30
	.DB  0x30,0x30,0x30,0x31,0x1F,0xF,0x0,0x0
	.DB  0x1F,0x3F,0x30,0x30,0x30,0x30,0x1F,0xF
	.DB  0x0,0x0,0x0,0x0,0x0,0x3F,0x3F,0x0
	.DB  0x0,0x0,0x0,0x0,0xF,0x1F,0x38,0x30
	.DB  0x30,0x38,0x1F,0xF,0x0,0x0,0xC,0x1C
	.DB  0x38,0x30,0x30,0x38,0x1F,0xF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xC,0xC
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0xFF
	.DW  _font10x16
	.DW  _0x3*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 15.12.2010
;Author  : sersne
;Company : home
;Comments:
;
;
;Chip type               : ATmega16
;Program type            : Application
;AVR Core Clock frequency: 10,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;
;#include <stdlib.h>
;#include "lcd.c"
;// lcd.c
;// LCD 3310 driver
;// Unbuffered version - very small memory footprint
;
;
;#include "lcd.h"
;#include "delay.h"
;
;//typedef enum { LCD_CMD  = 0, LCD_DATA = 1 } LcdCmdData;  //       LCD  (  )
;
;#define LCD_CMD  0
;#define LCD_DATA 1
;
;          //  
;//void lcd_send(unsigned char data, LcdCmdData cd);
;void lcd_send(unsigned char data, char cd);
;void lcd_delay(void);                            //  macro function
;
;
;const unsigned char font10x16 [][10] =
;{             // 
;
;// h
;        {0xfc,0xfe,0x07,0x03,0x03,0x07,0xfe,0xfc,0x00,0x00}, // 0 h
;
;        {0x18,0x0c,0x06,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00}, // 1 h
;
;        {0x8c,0xce,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c,0x00,0x00}, // 2 h
;
;        {0x0c,0x0e,0x07,0x03,0x43,0xe3,0xfe,0xbc,0x00,0x00}, // 3 h
;
;        {0xFF,0xFF,0xC0,0xC0,0xC0,0xC0,0xFF,0xFF,0x00,0x00}, // 4 h
;
;        {0xFF,0xFF,0xC3,0xC3,0xC3,0xC3,0xC3,0x83,0x00,0x00}, // 5 h
;
;        {0xFC,0xfe,0xC3,0xC3,0xC3,0xC3,0x8E,0x0C,0x00,0x00}, // 6 h
;
;        {0x03,0x03,0x03,0xE3,0xF3,0x1B,0x0F,0x07,0x00,0x00}, // 7 h
;
;        {0x3C,0xFE,0xC7,0xC3,0xC3,0xC7,0xFE,0x3C,0x00,0x00}, // 8 h
;
;        {0x3C,0x7E,0xC7,0xC3,0xC3,0xC7,0xFE,0xFC,0x00,0x00}, // 9 h
;
;        {0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00,0x00}, // - h
;
;        {0x00,0x00,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00,0x00}, // : h
;
;        {0x3C,0x7E,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C,0x00,0x00}, //   h
;
;        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, // 0x00
;
;// low
;        {0x1f,0x3f,0x38,0x30,0x30,0x38,0x3f,0x1f,0x00,0x00},  // 0 l
;
;        {0x30,0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x00,0x00}, // 1 l
;
;        {0x3f,0x3f,0x31,0x30,0x30,0x30,0x30,0x30,0x00,0x00}, // 2 l
;
;        {0x18,0x38,0x30,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 3 l
;
;        {0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x3F,0x00,0x00}, // 4 l
;
;        {0x30,0x30,0x30,0x30,0x30,0x31,0x1F,0x0F,0x00,0x00}, // 5 l
;
;        {0x1F,0x3F,0x30,0x30,0x30,0x30,0x1F,0x0F,0x00,0x00}, // 6 l
;
;        {0x00,0x00,0x00,0x3F,0x3F,0x00,0x00,0x00,0x00,0x00}, // 7 l
;
;        {0x0F,0x1F,0x38,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 8 l
;
;        {0x0C,0x1C,0x38,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 9 l
;
;
;        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, // - l
;
;        {0x00,0x00,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00,0x00}, // : l
;
;        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, //   l
;
;        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00} // 0x00
;
;};

	.DSEG
;
;
;void Lcd_Mode (unsigned char mode) 		// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
; 0000 001C {

	.CSEG
_Lcd_Mode:
;    if (mode > 3) return;
;	mode -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BRLO _0x4
	RJMP _0x20A0006
;    lcd_send( 0b00001000|((mode<<1|mode)&0b00000101), LCD_CMD ); 	//LCD mode
_0x4:
	LD   R30,Y
	LSL  R30
	LD   R26,Y
	OR   R30,R26
	ANDI R30,LOW(0x5)
	ORI  R30,8
	RJMP _0x20A0005
;}
;
;void lcd_delay(void)
;{
_lcd_delay:
;  int i;
;
;     for(i=-32000; i<32000; i++);  //  macro function
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,-32000
_0x6:
	__CPWRN 16,17,32000
	BRGE _0x7
	__ADDWRN 16,17,1
	RJMP _0x6
_0x7:
;}
	RJMP _0x20A0007
;
;
;void lcd_clear(void) {  //  
_lcd_clear:
;  unsigned int i;
;
;  lcd_goto_xy(0,0);
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CALL SUBOPT_0x0
	CALL SUBOPT_0x0
	RCALL _lcd_goto_xy
;  for (i=0;i<504;++i)
	__GETWRN 16,17,0
_0x9:
	__CPWRN 16,17,504
	BRSH _0xA
;    {
;     lcd_send(0x00, LCD_DATA);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
;    }
	__ADDWRN 16,17,1
	RJMP _0x9
_0xA:
;}
_0x20A0007:
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;
;void lcd_init(void)    //  LCD
;{
_lcd_init:
;    LCD_CE_PIN = 0;                   // Enable display controller (active low)
	CBI  0x15,0
;    LCD_CLK_PIN = 0;
	CBI  0x15,3
;    LCD_RST_PIN = 1;          //  Reset = 1
	SBI  0x15,4
;
;    LCD_Vdd = 1;              //    LCD
	SBI  0x15,5
;//	LCD_DDR |= LCD_RST_PIN | LCD_CE_PIN | LCD_DC_PIN | LCD_DATA_PIN | LCD_CLK_PIN;   // Set output bits on lcd port
;
;    delay_ms(15);             //    VCC LCD (max 30ms)
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    LCD_RST_PIN = 0;          //  LCD (Reset = 0)
	CBI  0x15,4
;    lcd_delay();
	RCALL _lcd_delay
;    LCD_RST_PIN = 1;          //   (Reset = 1)
	SBI  0x15,4
;
;    lcd_send(0x21, LCD_CMD);  //  LCD    
	CALL SUBOPT_0x2
;    lcd_send(0xC8, LCD_CMD);  // Set LCD Vop(Contrast = 72 = 80h + 48h)
	LDI  R30,LOW(200)
	CALL SUBOPT_0x3
;    lcd_send(0x06, LCD_CMD);  //   
	LDI  R30,LOW(6)
	CALL SUBOPT_0x3
;    lcd_send(0x13, LCD_CMD);  // LCD bias mode 1:48
	LDI  R30,LOW(19)
	CALL SUBOPT_0x3
;    lcd_send(0x20, LCD_CMD);  //  LCD   c ,   ( )
	LDI  R30,LOW(32)
	CALL SUBOPT_0x3
;    lcd_send(0x0C, LCD_CMD);  // LCD     (  )
	LDI  R30,LOW(12)
	CALL SUBOPT_0x3
;
;    lcd_clear();              //  lcd
	RCALL _lcd_clear
;}
	RET
;
;
;void lcd_contrast(unsigned char contrast)  {    //  
_lcd_contrast:
;	lcd_send(0x21, LCD_CMD);			    	//  LCD    
;	contrast -> Y+0
	CALL SUBOPT_0x2
;    lcd_send(0x80 | contrast, LCD_CMD);	    	// Set LCD Vop(Contrast 0-127 {0-7Fh} )
	LD   R30,Y
	ORI  R30,0x80
	CALL SUBOPT_0x3
;    lcd_send(0x20, LCD_CMD);				    //  ,  
	LDI  R30,LOW(32)
_0x20A0005:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _lcd_send
;}
_0x20A0006:
	ADIW R28,1
	RET
;
;
;/*
;void lcd_clear_area(unsigned int line, unsigned char startX, unsigned char endX)  //    
;{                                                                                 //  
; unsigned int i;                                                                  //  
;
;    int start = ((int)line)*84+((int)startX);  //    
;    int end = ((int)line)*84+((int)endX);      //    
;
;    lcd_goto_xy((start % LCD_X_RES),(start / LCD_X_RES));
;
;    for(i=start;i<end;i++) {      //     
;        lcd_send(0, LCD_DATA);
;    }
;}
;*/
;
;/*
;void lcd_clear_line(unsigned int line)  //   (8   )
;{
;   lcd_clear_area(line, 1, LCD_X_RES);
;}
;*/
;
;void lcd_goto_xy(unsigned int x, unsigned int y) //    X () Y ()
;{
_lcd_goto_xy:
;    lcd_send (x | 0x80, LCD_CMD);
;	x -> Y+2
;	y -> Y+0
	LDD  R30,Y+2
	ORI  R30,0x80
	CALL SUBOPT_0x3
;    lcd_send ((y-1) | 0x40, LCD_CMD);
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,1
	ORI  R30,0x40
	CALL SUBOPT_0x3
;}
	ADIW R28,4
	RET
;
;
;void lcd_chr(char chr, unsigned int x, unsigned int y)    //    LCD    
;{
_lcd_chr:
;  unsigned char i;
;
;    lcd_goto_xy(x,y);
	ST   -Y,R17
;	chr -> Y+5
;	x -> Y+3
;	y -> Y+1
;	i -> R17
	CALL SUBOPT_0x4
	CALL SUBOPT_0x4
	RCALL _lcd_goto_xy
;
;    for(i=0;i<10;i++)                 //   10 
	LDI  R17,LOW(0)
_0x18:
	CPI  R17,10
	BRSH _0x19
;	{
;      lcd_send(font10x16[chr-48][i], LCD_DATA);
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,48
	CALL SUBOPT_0x5
;    }
	SUBI R17,-1
	RJMP _0x18
_0x19:
;    lcd_goto_xy(x,y+1);
	CALL SUBOPT_0x4
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_goto_xy
;    i = 0;
	LDI  R17,LOW(0)
;    for(i=0;i<10;i++)                 //   10 
	LDI  R17,LOW(0)
_0x1B:
	CPI  R17,10
	BRSH _0x1C
;	{
;      lcd_send(font10x16[chr-34][i], LCD_DATA);
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,34
	CALL SUBOPT_0x5
;    }
	SUBI R17,-1
	RJMP _0x1B
_0x1C:
;
;
;//	lcd_send(0, LCD_DATA);           //    
;}
	LDD  R17,Y+0
	RJMP _0x20A0003
;
;/*
;void lcd_str(char *str)   //    LCD    
;{
;   while(*str)
;       lcd_chr(*str++);
;}
;*/
;
;void lcd_send(unsigned char data, char cd)   // Sends data to display controller
;{
_lcd_send:
;unsigned char i;
;
;    if(cd == LCD_DATA)                //   
	ST   -Y,R17
;	data -> Y+2
;	cd -> Y+1
;	i -> R17
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRNE _0x1D
;       LCD_DC_PIN = 1;                // 
	SBI  0x15,1
;    else
	RJMP _0x20
_0x1D:
;       LCD_DC_PIN = 0;                // 
	CBI  0x15,1
;
;	for(i=0;i<8;i++)
_0x20:
	LDI  R17,LOW(0)
_0x24:
	CPI  R17,8
	BRSH _0x25
;    {
;		if((data>>(7-i)) & 0x01)      //    DATA
	LDD  R22,Y+2
	CLR  R23
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	CALL __ASRW12
	ANDI R30,LOW(0x1)
	BREQ _0x26
;   		    LCD_DATA_PIN = 1;
	SBI  0x15,2
;	    else
	RJMP _0x29
_0x26:
;	   	    LCD_DATA_PIN = 0;
	CBI  0x15,2
;
;   		LCD_CLK_PIN = 1;              //  CLK
_0x29:
	SBI  0x15,3
;        LCD_CLK_PIN = 0;
	CBI  0x15,3
;	}
	SUBI R17,-1
	RJMP _0x24
_0x25:
;
;	// Data/DC can be used as button inputs when not sending to LCD (/w pullups)
;	// LCD_DDR &= ~(LCD_DATA_PIN | LCD_DC_PIN);
;	LCD_DATA_PIN = 1;
	SBI  0x15,2
;    LCD_DC_PIN   = 1;
	SBI  0x15,1
;}
	RJMP _0x20A0004
;
;#include <io.h>
;#include <delay.h>
;
;#include <math.h>
;
;
;// 1 Wire Bus functions
;#asm
   .equ __w1_port=0x15
   .equ __w1_bit=6
; 0000 0027 #endasm
;
;#include <1wire.h>
;
;// DS1820 temperature sensor functions
;#include <ds1820.h>
;#include <delay.h>
;// Declare your global variables here
;
;
;
;int T,X1,X2,X3;  // signed number for negative and positve temperature manipulating
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0037 {
_timer0_ovf_isr:
; 0000 0038 // Place your code here
; 0000 0039 
; 0000 003A }
	RETI
;
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 003E {
_timer1_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 003F // Place your code here
; 0000 0040 
; 0000 0041 TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
; 0000 0042 TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
; 0000 0043 
; 0000 0044 /*
; 0000 0045       switch (++seconds){
; 0000 0046         case 5: seconds = 0;
; 0000 0047 */
; 0000 0048 
; 0000 0049                      T =  ds1820_temperature_10(0)/10;     // read DS1820 every 5 sec.
	CALL SUBOPT_0x0
	CALL _ds1820_temperature_10
	MOVW R26,R30
	CALL SUBOPT_0x6
	MOVW R4,R30
; 0000 004A 
; 0000 004B 
; 0000 004C 
; 0000 004D                      // 
; 0000 004E                      X3=X2;
	MOVW R10,R8
; 0000 004F                      X2=T;
	MOVW R8,R4
; 0000 0050                      if (X2==X3)
	__CPWRR 10,11,8,9
	BRNE _0x34
; 0000 0051                      {
; 0000 0052 
; 0000 0053                            X1=T;
	MOVW R6,R4
; 0000 0054                      }
; 0000 0055 
; 0000 0056                      T=(X1);
_0x34:
	MOVW R4,R6
; 0000 0057 
; 0000 0058 
; 0000 0059 
; 0000 005A                      if(T<0)
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRGE _0x35
; 0000 005B                      {
; 0000 005C 
; 0000 005D 
; 0000 005E                              lcd_chr(60, 50, 3); //  
	CALL SUBOPT_0x7
; 0000 005F 
; 0000 0060                              T = abs(T);   // get only amplitude
; 0000 0061 
; 0000 0062                              lcd_chr((T%10)+48,40,3);
; 0000 0063 
; 0000 0064                              if ((T/10) == 0)
	SBIW R30,0
	BRNE _0x36
; 0000 0065                              {
; 0000 0066                                      lcd_chr(58, 30, 3);     // put -
	LDI  R30,LOW(58)
	ST   -Y,R30
	CALL SUBOPT_0x8
; 0000 0067                                      lcd_chr(61, 20, 3);     // 0x00
	LDI  R30,LOW(61)
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP _0x3F
; 0000 0068 //                                     lcd_chr((T/10)+48,40,3);
; 0000 0069                              }
; 0000 006A                              else
_0x36:
; 0000 006B                              {
; 0000 006C                                      lcd_chr(58, 20, 3);     // put -
	LDI  R30,LOW(58)
	CALL SUBOPT_0x9
; 0000 006D                                      lcd_chr((T/10)+48,30,3);
	MOVW R26,R4
	CALL SUBOPT_0x6
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
_0x3F:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_chr
; 0000 006E 
; 0000 006F                              }
; 0000 0070 
; 0000 0071                      }
; 0000 0072                      else
	RJMP _0x38
_0x35:
; 0000 0073                      {
; 0000 0074 
; 0000 0075                              lcd_chr(60, 50, 3); //  
	CALL SUBOPT_0x7
; 0000 0076 
; 0000 0077                              T = abs(T);   // get only amplitude
; 0000 0078 
; 0000 0079                              lcd_chr((T%10)+48,40,3); //  
; 0000 007A 
; 0000 007B                              if ((T/10) == 0)
	SBIW R30,0
	BRNE _0x39
; 0000 007C                              {
; 0000 007D 
; 0000 007E                                      lcd_chr(61, 20, 3);     // 0x00
	LDI  R30,LOW(61)
	CALL SUBOPT_0x9
; 0000 007F                                      lcd_chr(61, 30, 3);     // 0x00
	LDI  R30,LOW(61)
	RJMP _0x40
; 0000 0080 //                                     lcd_chr((T/10)+48,40,3);
; 0000 0081                              }
; 0000 0082                              else
_0x39:
; 0000 0083                              {
; 0000 0084 //                                     lcd_chr(58, 20, 3);     // put -
; 0000 0085                                      lcd_chr((T/10)+48,30,3);
	MOVW R26,R4
	CALL SUBOPT_0x6
	SUBI R30,-LOW(48)
_0x40:
	ST   -Y,R30
	CALL SUBOPT_0x8
; 0000 0086 
; 0000 0087                              }
; 0000 0088 
; 0000 0089 
; 0000 008A                      }
_0x38:
; 0000 008B 
; 0000 008C /*
; 0000 008D       }
; 0000 008E */
; 0000 008F 
; 0000 0090 
; 0000 0091 
; 0000 0092 
; 0000 0093 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Declare your global variables here
;
;void main(void)
; 0000 0098 {
_main:
; 0000 0099 // Declare your local variables here
; 0000 009A 
; 0000 009B 
; 0000 009C // Input/Output Ports initialization
; 0000 009D // Port A initialization
; 0000 009E // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 009F // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 00A0 PORTA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 00A1 DDRA=0xFF;
	OUT  0x1A,R30
; 0000 00A2 
; 0000 00A3 // Port B initialization
; 0000 00A4 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00A5 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 00A6 PORTB=0xFF;
	OUT  0x18,R30
; 0000 00A7 DDRB=0xFF;
	OUT  0x17,R30
; 0000 00A8 
; 0000 00A9 // Port C initialization
; 0000 00AA // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00AB // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 00AC PORTC=0xFF;
	OUT  0x15,R30
; 0000 00AD DDRC=0xFF;
	OUT  0x14,R30
; 0000 00AE 
; 0000 00AF // Port D initialization
; 0000 00B0 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00B1 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 00B2 PORTD=0xFF;
	OUT  0x12,R30
; 0000 00B3 DDRD=0xFF;
	OUT  0x11,R30
; 0000 00B4 
; 0000 00B5 //  Timer 0
; 0000 00B6 //TCCR0=0x00;
; 0000 00B7 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 00B8 TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
; 0000 00B9 
; 0000 00BA //  Timer 1
; 0000 00BB TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 00BC TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00BD TCNT1H=0xC2;
	LDI  R30,LOW(194)
	OUT  0x2D,R30
; 0000 00BE TCNT1L=0xF7;
	LDI  R30,LOW(247)
	OUT  0x2C,R30
; 0000 00BF OCR1BL=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
; 0000 00C0 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00C1 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00C2 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00C3 
; 0000 00C4 // Timer/Counter 2 initialization
; 0000 00C5 // Clock source: System Clock
; 0000 00C6 // Clock value: Timer2 Stopped
; 0000 00C7 // Mode: Normal top=FFh
; 0000 00C8 // OC2 output: Disconnected
; 0000 00C9 //ASSR=0x00;
; 0000 00CA //TCCR2=0x00;
; 0000 00CB //TCNT2=0x00;
; 0000 00CC //OCR2=0x00;
; 0000 00CD 
; 0000 00CE // External Interrupt(s) initialization
; 0000 00CF // INT0: Off
; 0000 00D0 // INT1: Off
; 0000 00D1 // INT2: Off
; 0000 00D2 MCUCR=0x00;
	OUT  0x35,R30
; 0000 00D3 MCUCSR=0x00;
	OUT  0x34,R30
; 0000 00D4 
; 0000 00D5 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00D6 TIMSK=0x05;
	LDI  R30,LOW(5)
	OUT  0x39,R30
; 0000 00D7 
; 0000 00D8 // Analog Comparator initialization
; 0000 00D9 // Analog Comparator: Off
; 0000 00DA // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00DB ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00DC SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00DD 
; 0000 00DE       X1=0;
	CLR  R6
	CLR  R7
; 0000 00DF       X2=0;
	CLR  R8
	CLR  R9
; 0000 00E0       X3=0;
	CLR  R10
	CLR  R11
; 0000 00E1       T = 0;
	CLR  R4
	CLR  R5
; 0000 00E2 
; 0000 00E3 
; 0000 00E4 // Global enable interrupts
; 0000 00E5 
; 0000 00E6    lcd_init();
	RCALL _lcd_init
; 0000 00E7 
; 0000 00E8 // 1 Wire Bus initialization
; 0000 00E9    w1_init();
	CALL _w1_init
; 0000 00EA 
; 0000 00EB #asm("sei")
	sei
; 0000 00EC 
; 0000 00ED    lcd_contrast(0x40);
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _lcd_contrast
; 0000 00EE 
; 0000 00EF //   Lcd_Mode(0);
; 0000 00F0 //   lcd_goto_xy(1,2);
; 0000 00F1 //   lcd_str(str1);
; 0000 00F2 
; 0000 00F3    Lcd_Mode(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _Lcd_Mode
; 0000 00F4    lcd_send(0x0C, LCD_CMD);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x3
; 0000 00F5 //   lcd_goto_xy(15,4);
; 0000 00F6 //   lcd_str(str2);
; 0000 00F7 
; 0000 00F8 /*
; 0000 00F9    lcd_chr(str1[0], 20, 3);
; 0000 00FA 
; 0000 00FB    lcd_chr(str1[1], 30, 3);
; 0000 00FC 
; 0000 00FD    lcd_chr(str1[2], 40, 3);
; 0000 00FE 
; 0000 00FF    lcd_chr(str1[3], 50, 3);
; 0000 0100 */
; 0000 0101 
; 0000 0102 //   Lcd_Mode(2);
; 0000 0103 //   lcd_send(0x0D, LCD_CMD);
; 0000 0104 //   lcd_goto_xy(25,6);
; 0000 0105 //   lcd_str(str1);
; 0000 0106 
; 0000 0107 
; 0000 0108 
; 0000 0109 while (1)
_0x3B:
; 0000 010A       {
; 0000 010B       // Place your code here
; 0000 010C 
; 0000 010D       };
	RJMP _0x3B
; 0000 010E }
_0x3E:
	RJMP _0x3E

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

	.DSEG

	.CSEG

	.CSEG

	.CSEG
_ds1820_select:
	ST   -Y,R17
	CALL _w1_init
	CPI  R30,0
	BRNE _0x2040003
	LDI  R30,LOW(0)
	RJMP _0x20A0004
_0x2040003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x2040004
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
_0x2040006:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	CALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2040006
	RJMP _0x2040008
_0x2040004:
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
_0x2040008:
	LDI  R30,LOW(1)
_0x20A0004:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_ds1820_read_spd:
	CALL __SAVELOCR4
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_select
	CPI  R30,0
	BRNE _0x2040009
	LDI  R30,LOW(0)
	RJMP _0x20A0002
_0x2040009:
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds1820_scratch_pad
_0x204000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x204000B
	LDI  R30,LOW(___ds1820_scratch_pad)
	LDI  R31,HIGH(___ds1820_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _w1_dow_crc8
	CALL __LNEGB1
_0x20A0002:
	CALL __LOADLOCR4
_0x20A0003:
	ADIW R28,6
	RET
_ds1820_temperature_10:
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_select
	CPI  R30,0
	BRNE _0x204000D
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x20A0001
_0x204000D:
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
	LDI  R30,LOW(550)
	LDI  R31,HIGH(550)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_read_spd
	CPI  R30,0
	BRNE _0x204000E
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x20A0001
_0x204000E:
	CALL _w1_init
	__GETB1HMN ___ds1820_scratch_pad,1
	LDI  R30,LOW(0)
	MOVW R26,R30
	LDS  R30,___ds1820_scratch_pad
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
_0x20A0001:
	ADIW R28,2
	RET

	.CSEG

	.CSEG

	.DSEG
_font10x16:
	.BYTE 0x118
___ds1820_scratch_pad:
	.BYTE 0x9
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(33)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	SUBI R30,LOW(-_font10x16)
	SBCI R31,HIGH(-_font10x16)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(60)
	ST   -Y,R30
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_chr
	ST   -Y,R5
	ST   -Y,R4
	CALL _abs
	MOVW R4,R30
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	SUBI R30,-LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_chr
	MOVW R26,R4
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_chr

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_chr


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x9C4
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x4B0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x2F
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0xFD
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x3CF
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x7
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x25
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USW 0xC8
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x7
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x2B
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0xFA
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x11
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
