// lcd.c
// LCD 3310 driver
// Unbuffered version - very small memory footprint


#include "lcd.h"
#include "delay.h"

//typedef enum { LCD_CMD  = 0, LCD_DATA = 1 } LcdCmdData;  //       LCD  (  )

#define LCD_CMD  0
#define LCD_DATA 1

          //  
//void lcd_send(unsigned char data, LcdCmdData cd);
void lcd_send(unsigned char data, char cd);
void lcd_delay(void);                            //  macro function


const unsigned char font10x16 [][10] = 
{             //  

// h
        {0xfc,0xfe,0x07,0x03,0x03,0x07,0xfe,0xfc,0x00,0x00}, // 0 h

        {0x18,0x0c,0x06,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00}, // 1 h

        {0x8c,0xce,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c,0x00,0x00}, // 2 h
        
        {0x0c,0x0e,0x07,0x03,0x43,0xe3,0xfe,0xbc,0x00,0x00}, // 3 h
        
        {0xFF,0xFF,0xC0,0xC0,0xC0,0xC0,0xFF,0xFF,0x00,0x00}, // 4 h
        
        {0xFF,0xFF,0xC3,0xC3,0xC3,0xC3,0xC3,0x83,0x00,0x00}, // 5 h
        
        {0xFC,0xfe,0xC3,0xC3,0xC3,0xC3,0x8E,0x0C,0x00,0x00}, // 6 h
        
        {0x03,0x03,0x03,0xE3,0xF3,0x1B,0x0F,0x07,0x00,0x00}, // 7 h
        
        {0x3C,0xFE,0xC7,0xC3,0xC3,0xC7,0xFE,0x3C,0x00,0x00}, // 8 h
        
        {0x3C,0x7E,0xC7,0xC3,0xC3,0xC7,0xFE,0xFC,0x00,0x00}, // 9 h

        {0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00,0x00}, // - h

        {0x00,0x00,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00,0x00}, // : h

        {0x3C,0x7E,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C,0x00,0x00}, //   h
        
        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, // 0x00        
                
// low
        {0x1f,0x3f,0x38,0x30,0x30,0x38,0x3f,0x1f,0x00,0x00},  // 0 l 

        {0x30,0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x00,0x00}, // 1 l
        
        {0x3f,0x3f,0x31,0x30,0x30,0x30,0x30,0x30,0x00,0x00}, // 2 l

        {0x18,0x38,0x30,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 3 l

        {0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x3F,0x00,0x00}, // 4 l
        
        {0x30,0x30,0x30,0x30,0x30,0x31,0x1F,0x0F,0x00,0x00}, // 5 l

        {0x1F,0x3F,0x30,0x30,0x30,0x30,0x1F,0x0F,0x00,0x00}, // 6 l
        
        {0x00,0x00,0x00,0x3F,0x3F,0x00,0x00,0x00,0x00,0x00}, // 7 l

        {0x0F,0x1F,0x38,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 8 l

        {0x0C,0x1C,0x38,0x30,0x30,0x38,0x1F,0x0F,0x00,0x00}, // 9 l
        

        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, // - l
        
        {0x00,0x00,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00,0x00}, // : l

        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, //   l

        {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00} // 0x00
        
};

   
void Lcd_Mode (unsigned char mode) 		// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
{                      
    if (mode > 3) return;
    lcd_send( 0b00001000|((mode<<1|mode)&0b00000101), LCD_CMD ); 	//LCD mode   
}
                                           
void lcd_delay(void)
{ 
  int i;  
  
     for(i=-32000; i<32000; i++);  //  macro function
}


void lcd_clear(void) {  //  
  unsigned int i;    

  lcd_goto_xy(0,0);  
  for (i=0;i<504;++i)      
    {
     lcd_send(0x00, LCD_DATA);
    }  
}


void lcd_init(void)    //  LCD
{
    LCD_CE_PIN = 0;                   // Enable display controller (active low)
    LCD_CLK_PIN = 0;
    LCD_RST_PIN = 1;          //  Reset = 1

    LCD_Vdd = 1;              //    LCD
//	LCD_DDR |= LCD_RST_PIN | LCD_CE_PIN | LCD_DC_PIN | LCD_DATA_PIN | LCD_CLK_PIN;   // Set output bits on lcd port
	
    delay_ms(15);             //    VCC LCD (max 30ms)
    LCD_RST_PIN = 0;          //  LCD (Reset = 0)
    lcd_delay();
    LCD_RST_PIN = 1;          //   (Reset = 1)
  
    lcd_send(0x21, LCD_CMD);  //  LCD    
    lcd_send(0xC8, LCD_CMD);  // Set LCD Vop(Contrast = 72 = 80h + 48h)   
    lcd_send(0x06, LCD_CMD);  //   
    lcd_send(0x13, LCD_CMD);  // LCD bias mode 1:48
    lcd_send(0x20, LCD_CMD);  //  LCD   c ,   ( )
    lcd_send(0x0C, LCD_CMD);  // LCD     (  )

    lcd_clear();              //  lcd
}  


void lcd_contrast(unsigned char contrast)  {    //  
	lcd_send(0x21, LCD_CMD);			    	//  LCD    
    lcd_send(0x80 | contrast, LCD_CMD);	    	// Set LCD Vop(Contrast 0-127 {0-7Fh} )
    lcd_send(0x20, LCD_CMD);				    //  ,       
}


/*
void lcd_clear_area(unsigned int line, unsigned char startX, unsigned char endX)  //    
{                                                                                 //  
 unsigned int i;                                                                  //  

    int start = ((int)line)*84+((int)startX);  //    
    int end = ((int)line)*84+((int)endX);      //    
	
    lcd_goto_xy((start % LCD_X_RES),(start / LCD_X_RES));
    
    for(i=start;i<end;i++) {      //     
        lcd_send(0, LCD_DATA);
    }
}
*/

/*
void lcd_clear_line(unsigned int line)  //   (8   )
{  
   lcd_clear_area(line, 1, LCD_X_RES);
}
*/

void lcd_goto_xy(unsigned int x, unsigned int y) //    X () Y ()
{
    lcd_send (x | 0x80, LCD_CMD);
    lcd_send ((y-1) | 0x40, LCD_CMD);  
}


void lcd_chr(char chr, unsigned int x, unsigned int y)    //    LCD    
{
  unsigned char i;
    
    lcd_goto_xy(x,y);
    
    for(i=0;i<10;i++)                 //   10 
	{
      lcd_send(font10x16[chr-48][i], LCD_DATA);
    }
    lcd_goto_xy(x,y+1);
    i = 0;
    for(i=0;i<10;i++)                 //   10 
	{
      lcd_send(font10x16[chr-34][i], LCD_DATA);
    }


//	lcd_send(0, LCD_DATA);           //    
}

/*
void lcd_str(char *str)   //    LCD    
{  
   while(*str) 
       lcd_chr(*str++);
}
*/

void lcd_send(unsigned char data, char cd)   // Sends data to display controller
{ 
unsigned char i;

    if(cd == LCD_DATA)                //   
       LCD_DC_PIN = 1;                // 
    else   
       LCD_DC_PIN = 0;                // 

	for(i=0;i<8;i++) 
    {
		if((data>>(7-i)) & 0x01)      //    DATA
   		    LCD_DATA_PIN = 1;                 
	    else 
	   	    LCD_DATA_PIN = 0;	                  

   		LCD_CLK_PIN = 1;              //  CLK    
        LCD_CLK_PIN = 0;   
	}

	// Data/DC can be used as button inputs when not sending to LCD (/w pullups)
	// LCD_DDR &= ~(LCD_DATA_PIN | LCD_DC_PIN);
	LCD_DATA_PIN = 1;
    LCD_DC_PIN   = 1;
}
 
