/*
** lcd.h
**
** LCD 3310 driver
** Target: ATMEGA : CodeVisionAVR
**
*/

#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 84
#define LCD_Y_RES 48
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)

/* Pinout for LCD */
#define LCD_CLK_PIN 	PORTC.3
#define LCD_DATA_PIN 	PORTC.2
#define LCD_DC_PIN 		PORTC.1
#define LCD_CE_PIN 		PORTC.0
#define LCD_RST_PIN 	PORTC.4
#define LCD_Vdd      	PORTC.5
//#define LCD_PORT		PORTC
#define LCD_DDR			DDRC

/* Special Chars */
#define ARROW_RIGHT	ICON(0)
#define ARROW_LEFT 	ICON(1)
#define ARROW_UP 	ICON(2)
#define ARROW_DOWN 	ICON(3)
#define STOP 		ICON(4)
#define PLAY	 	ICON(5)

/* Function for my special characters */
//#define	ICON(x)		'z'+1+x

void lcd_init(void);
void lcd_contrast(unsigned char contrast);
void lcd_clear(void);
/*
void lcd_clear_area(unsigned int line, unsigned char startX, unsigned char endX);
void lcd_clear_line(unsigned int line);
*/

void lcd_goto_xy(unsigned int x, unsigned int y);
void lcd_chr(char chr, unsigned int x, unsigned int y);
//void lcd_str(char *str);
#endif



